var alertram = 90;
var alertdisk = 90;
var alertloadavg = 2;

var lastStats = {};


function deleteSerial(serial) {
  if (confirm("Etes vous sur de vouloir supprimer l'IPBX " + serial + " ?")) {
    var tr = $("tr[data-serial='" + serial + "']");
    var connected = ($(tr).attr("data-connected") === "true");
    if (connected) {
      alert("Impossible de supprimer un IPBX connecté !");
      return;
    }
    $(tr).remove();
    $.get("main.php?action=del&serial=" + serial, () => {
    });
  }
}

function UpdateConnexion() {
  $.getJSON("main.php?action=connected", function (data) {
    var ports = data;
    $("[data-type='ipbx']").each(function (index) {
      var tr = this;
      var port1 = $(tr).attr('data-port1');
      var port2 = $(tr).attr('data-port2');
      if (ports.indexOf(port1) > -1 || ports.indexOf(port2) > -1) {
        $(tr).find('.connectstatus').html("<img class='connectstatus' src='img/connected.png' />");
        $(tr).find('.connectstatus').attr("data-value", "1");
        $(tr).attr('data-connected', true);
      }
      else {
        $(tr).find('.connectstatus').html("<img class='connectstatus' src='img/disconnected.png' />");
        $(tr).find('.connectstatus').attr("data-value", "0");
        $(tr).attr('data-connected', false);
      }
    });
    filtrer();
  });
}



function getAllLastPBXStatsAsync() {
  return new Promise(async (resolve, reject) => {
    var trs = $("#tbody-pbx-table").find('tr');
    var promesses = [];
    for (var item of trs) {
      var serial = $(item).attr("data-serial");
      promesses.push(await getLastPBXStatsAsync(serial));
    }
    await Promise.all(promesses);

    $("[data-has-stats='false']").find('.td-stats').html('');
    var afficherAlarmes = $("#checkbox-afficher-alarmes").prop("checked");
    if (afficherAlarmes) {
      $("[data-has-alarm='true']").show();
    }


    resolve();
  });
}


function getLastPBXStatsAsync(serial) {
  return new Promise(async (resolve, reject) => {
    $.getJSON("main.php?action=lastpbxstats&serial=" + serial, (data) => {
      var tr = $("[data-serial='" + serial + "']");

      $(tr).find('.td-stats').css('color', '');
      $(tr).find('.td-stats').html("<span class='glyphicon glyphicon-refresh rotate'></span>");
      $(tr).find('.td-details').html('');

      if (data.length === 0) {
        $(tr).attr('data-has-stats', false);
        $(tr).find('.td-stats').html('');
        $(tr).find('.td-alarm').html("<i class='glyphicon glyphicon-warning-sign'></i>");
        $(tr).attr('data-has-alarm', true);
        resolve(null);
        return;
      }

      var d = data[0];
      lastStats[serial] = d;

      updatePBXSettingsTable(tr);

      resolve(d);
    });
  });
}


function updateAllPBXsettingsTable() {
  var trs = $("#tbody-pbx-table").find('tr');
  for (var tr of trs) {
    updatePBXSettingsTable(tr);
  }
}


function updatePBXSettingsTable(tr) {
  var serial = $(tr).attr("data-serial");
  var d = getStatsSerialFromCache(serial);

  $(tr).attr('data-has-stats', false);
  $(tr).find('.td-stats-mem').css('color', '');
  $(tr).find('.td-stats-disk').css('color', '');
  $(tr).find('.td-stats-cpu').css('color', '');

  if (d !== null) {
    $(tr).attr('data-has-stats', true);

    var usedrampercent = d.totalram > 0 ? (d.totalram - d.availableram) * 100 / d.totalram : 0;
    var totaldisk = parseInt(d.totaldisk);
    var freedisk = parseInt(d.freedisk);
    var useddisk = totaldisk - freedisk;
    var useddiskpercent = totaldisk > 0 ? ((useddisk * 100) / totaldisk) : 0;
    var usedSwapPercent = d.swaptotal > 0 ? (d.swaptotal - d.swapfree) * 100 / d.swaptotal : 0;

    var alert = false;
    if (usedrampercent > alertram) {
      alert = true;
      $(tr).find('.td-stats-mem').css('color', 'red');
    }
    if (useddiskpercent > alertdisk) {
      alert = true;
      $(tr).find('.td-stats-disk').css('color', 'red');
    }
    if (d.loadavg1 > alertloadavg) {
      alert = true;
      $(tr).find('.td-stats-cpu').css('color', 'red');
    }


    var lastSeen = moment.unix(d.lastseen).format("DD/MM/YYYY HH:mm:ss");

    $(tr).find('.td-stats-lastseen').html(lastSeen);
    $(tr).find('.td-stats-version').html(d.version);
    $(tr).find('.td-stats-cpu').html(d.loadavg1);
    $(tr).find('.td-stats-mem').html(usedrampercent.toFixed(0) + " %");
    $(tr).find('.td-stats-swap').html(usedSwapPercent.toFixed(0) + " %");
    $(tr).find('.td-stats-disk').html(useddiskpercent.toFixed(1) + " %");
    $(tr).find('.td-stats-calls').html(d.calls);


    $(tr).find('.td-stats-lastseen').attr("data-value", d.lastseen);
    $(tr).find('.td-stats-version').attr("data-value", d.version);
    $(tr).find('.td-stats-cpu').attr("data-value", d.loadavg1);
    $(tr).find('.td-stats-mem').attr("data-value", usedrampercent);
    $(tr).find('.td-stats-swap').attr("data-value", usedSwapPercent);
    $(tr).find('.td-stats-disk').attr("data-value", useddiskpercent);
    $(tr).find('.td-stats-calls').attr("data-value", d.calls);

    if (alert) {
      $(tr).find('.td-alarm').html("<i class='glyphicon glyphicon-warning-sign'></i>");
      $(tr).attr('data-has-alarm', true);
    }
    else {
      $(tr).find('.td-alarm').html("");
      $(tr).attr('data-has-alarm', false);
    }

    $(tr).find('.td-details').html("<a href='#' onclick='displayLastStatsAsync(\"" + serial + "\")'><i class='glyphicon glyphicon-stats'></i> voir</a>");
  }
}



function getSettingsAsync() {
  return new Promise(async (resolve, reject) => {
    $.getJSON("main.php?action=getsettings", (data) => {
      resolve(data);
    });
  });
}



function saveSettingsAsync() {
  return new Promise(async (resolve, reject) => {
    alertram = $("#input-alert-mem").val();
    alertdisk = $("#input-alert-disk").val();
    alertloadavg = $("#input-alert-loadavg").val();
    $("#modalsettings").modal('toggle');
    $.getJSON("main.php?action=setsettings&alert-mem=" + alertram + "&alert-disk=" + alertdisk + "&alert-loadavg=" + alertloadavg, () => {
      updateAllPBXsettingsTable();
      resolve();
    });
  });
}



function getPBXStatsAsync(serial, days) {
  return new Promise(async (resolve, reject) => {
    $.getJSON("main.php?action=pbxstats&serial=" + serial + "&days=" + days, (data) => {
      resolve(data);
    });
  });
}


async function drawChart(placeholder, historysource, ymax, yticks) {
  var chartdata = new google.visualization.DataTable();
  chartdata.addColumn('string', 'Time');
  chartdata.addColumn('number', 'Value');
  chartdata.addRows(historysource);
  var chartoptions = {
    legend: {
      position: 'none'
    },
    axisTitlesPosition: 'none',
    enableInteractivity: true,
    hAxis: {
      textPosition: 'none'
    },
    vAxis: {
      minValue: 0,
      maxValue: ymax,
      ticks: yticks !== null ? yticks : 'auto'
    },
    lineWidth: 1,
    pointsVisible: false,
    chartArea: {
      left: 20,
      right: 0
    },
    backgroundColor: {
      stroke: '#cdcdcd',
      strokeWidth: 1
    }
  }
  var chart = new google.visualization.LineChart(placeholder);
  chart.draw(chartdata, chartoptions);
}




function getStatsSerialFromCache(serial) {
  return lastStats[serial] !== undefined ? lastStats[serial] : null;
}

async function displayLastStatsAsync(serial) {
  $("#modalstats").modal("show");
  $("#modalstats").find('.chart').html('Loading...');

  $(".title-loading-stats").show();
  $(".stats-nostats").hide();
  $("#div-stats").hide();
  $(".stat-value").html('');
  var stats = getStatsSerialFromCache(serial);
  if (stats !== null) {
    var totalram = stats.totalram / 1024;
    var usedram = (stats.totalram - stats.availableram) / 1024;
    var usedrampercent = (stats.totalram - stats.availableram) * 100 / stats.totalram;
    var totalswap = stats.swaptotal / 1024;
    var usedwap = (stats.swaptotal - stats.swapfree) / 1024;
    var usedswappercent = (stats.swaptotal - stats.swapfree) * 100 / stats.swaptotal;
    var momdate = moment.unix(stats.date);
    var totalpeers = parseInt(stats.peersoffline) + parseInt(stats.peersonline);
    var diffdate = moment().diff(momdate, 'seconds');
    var totaldisk = parseInt(stats.totaldisk);
    var freedisk = parseInt(stats.freedisk);
    var useddisk = totaldisk - freedisk;
    var useddiskpercent = ((useddisk * 100) / totaldisk).toFixed(2);

    var lastSeen = moment.unix(stats.lastseen).format("DD/MM/YYYY HH:mm:ss");

    $(".stat-date").html(momdate.format("L LTS") + " - " + momdate.fromNow());
    if (diffdate > 120) {
      $(".stat-date").css('color', 'red');
    }
    else {
      $(".stat-date").css('color', '');
    }
    $(".stat-serial").html(stats.serial);
    $(".stat-version").html(stats.version);
    $(".stat-memoire").html(usedram.toFixed(0) + " MB / " + totalram.toFixed(0) + " MB (" + usedrampercent.toFixed(2) + "%)");
    if (usedrampercent > alertram)
      $(".stat-memoire").addClass('text-danger');
    else
      $(".stat-memoire").removeClass('text-danger');

    $(".stat-swap").html(usedwap.toFixed(0) + " MB / " + totalswap.toFixed(0) + " (" + usedswappercent.toFixed(2) + "%)");

    $(".stat-disk").html(useddisk + " MB / " + totaldisk + " (" + useddiskpercent + "%)");
    if (useddiskpercent > alertdisk)
      $(".stat-disk").addClass('text-danger');
    else
      $(".stat-disk").removeClass('text-danger');

    $(".stat-loadavg").html(stats.loadavg1);
    $(".stat-calls").html(stats.calls + " appels en cours");
    $(".stat-peers").html(stats.peersonline + " connectés / " + totalpeers + " total");
    $(".stat-trunks").html(stats.registered + " trunks enregistrés");
    $("#div-stats").show();

    var historysource = await getPBXStatsAsync(serial, 1);

    //Il faut laisser le temps à la page d'afficher le modal, sinon la taille du modal est à 0, donc le graph s'affiche pas.
    setTimeout(() => {
      var dataloadavg = [];
      var maxLoadAvg = 2;
      var datamemory = [];
      for (var h of historysource) {
        var date = moment.unix(h.date).format("HH:mm");
        dataloadavg.push([date, parseFloat(h.loadavg1)]);
        if (h.loadavg1 > maxLoadAvg) {
          maxLoadAvg = Math.ceil(h.loadavg1);
        }
        datamemory.push([date, ((parseInt(h.totalram) - parseInt(h.availableram)) * 100) / stats.totalram]);
      }
      drawChart($('.chart-loadavg')[0], dataloadavg, null, [0, maxLoadAvg]);
      drawChart($('.chart-memory')[0], datamemory, 100, [0, 25, 50, 75, 100]);
    }, 1000);
  }
  else {
    $(".stats-nostats").show();
  }
  $(".title-loading-stats").hide();
}

function isFiltered(tr) {
  var s = $('#inputfiltre').val().toUpperCase();
  if (s === "") {
    return false;
  }
  else {
    if ($(tr).attr('data-nom').toUpperCase().indexOf(s) === -1
      && $(tr).attr('data-serial').toUpperCase().indexOf(s) === -1
      && $(tr).attr('data-port1').toUpperCase().indexOf(s) === -1
      && $(tr).attr('data-port2').toUpperCase().indexOf(s) === -1) //rien ne correspond
    {
      return true; //le résultat est donc filtré puisque rien ne correspond
    }
    else {
      return false;
    }
  }
}

function filtrer() {
  var afficherDecos = $("#checkbox-afficher-deconnectes").prop("checked");
  var afficherAlarmes = $("#checkbox-afficher-alarmes").prop("checked");
  $("[data-type='ipbx']").each(function (index) {
    if (isFiltered($(this))) {
      $(this).hide();
    }
    else {
      var connected = ($(this).attr("data-connected") === "true");
      var alarme = ($(this).attr("data-has-alarm") === "true");
      if (!connected) {
        if (afficherDecos) {
          $(this).show();
        }
        else {
          $(this).hide();
        }
      }
      else {
        $(this).show();
      }

      if (afficherAlarmes && !alarme) {
        $(this).hide();
      }
    }
  });
}var alertram=90,alertdisk=90,alertloadavg=2,lastStats={};function deleteSerial(t){if(confirm("Etes vous sur de vouloir supprimer l'IPBX "+t+" ?")){var a=$("tr[data-serial='"+t+"']");if("true"===$(a).attr("data-connected"))return void alert("Impossible de supprimer un IPBX connecté !");$(a).remove(),$.get("main.php?action=del&serial="+t,(()=>{}))}}function UpdateConnexion(){$.getJSON("main.php?action=connected",(function(t){var a=t;$("[data-type='ipbx']").each((function(t){var s=this,e=$(s).attr("data-port1"),r=$(s).attr("data-port2");a.indexOf(e)>-1||a.indexOf(r)>-1?($(s).find(".connectstatus").html("<img class='connectstatus' src='img/connected.png' />"),$(s).find(".connectstatus").attr("data-value","1"),$(s).attr("data-connected",!0)):($(s).find(".connectstatus").html("<img class='connectstatus' src='img/disconnected.png' />"),$(s).find(".connectstatus").attr("data-value","0"),$(s).attr("data-connected",!1))})),filtrer()}))}function getAllLastPBXStatsAsync(){return new Promise((async(t,a)=>{var s=$("#tbody-pbx-table").find("tr"),e=[];for(var r of s){var i=$(r).attr("data-serial");e.push(await getLastPBXStatsAsync(i))}await Promise.all(e),$("[data-has-stats='false']").find(".td-stats").html(""),$("#checkbox-afficher-alarmes").prop("checked")&&$("[data-has-alarm='true']").show(),t()}))}function getLastPBXStatsAsync(t){return new Promise((async(a,s)=>{$.getJSON("main.php?action=lastpbxstats&serial="+t,(s=>{var e=$("[data-serial='"+t+"']");if($(e).find(".td-stats").css("color",""),$(e).find(".td-stats").html("<span class='glyphicon glyphicon-refresh rotate'></span>"),$(e).find(".td-details").html(""),0===s.length)return $(e).attr("data-has-stats",!1),$(e).find(".td-stats").html(""),$(e).find(".td-alarm").html("<i class='glyphicon glyphicon-warning-sign'></i>"),$(e).attr("data-has-alarm",!0),void a(null);var r=s[0];lastStats[t]=r,updatePBXSettingsTable(e),a(r)}))}))}function updateAllPBXsettingsTable(){var t=$("#tbody-pbx-table").find("tr");for(var a of t)updatePBXSettingsTable(a)}function updatePBXSettingsTable(t){var a=$(t).attr("data-serial"),s=getStatsSerialFromCache(a);if($(t).attr("data-has-stats",!1),$(t).find(".td-stats-mem").css("color",""),$(t).find(".td-stats-disk").css("color",""),$(t).find(".td-stats-cpu").css("color",""),null!==s){$(t).attr("data-has-stats",!0);var e=s.totalram>0?100*(s.totalram-s.availableram)/s.totalram:0,r=parseInt(s.totaldisk),i=parseInt(s.freedisk),n=r>0?100*(r-i)/r:0,l=s.swaptotal>0?100*(s.swaptotal-s.swapfree)/s.swaptotal:0,d=!1;e>alertram&&(d=!0,$(t).find(".td-stats-mem").css("color","red")),n>alertdisk&&(d=!0,$(t).find(".td-stats-disk").css("color","red")),s.loadavg1>alertloadavg&&(d=!0,$(t).find(".td-stats-cpu").css("color","red"));var o=moment.unix(s.lastseen).format("DD/MM/YYYY HH:mm:ss");$(t).find(".td-stats-lastseen").html(o),$(t).find(".td-stats-version").html(s.version),$(t).find(".td-stats-cpu").html(s.loadavg1),$(t).find(".td-stats-mem").html(e.toFixed(0)+" %"),$(t).find(".td-stats-swap").html(l.toFixed(0)+" %"),$(t).find(".td-stats-disk").html(n.toFixed(1)+" %"),$(t).find(".td-stats-calls").html(s.calls),$(t).find(".td-stats-lastseen").attr("data-value",s.lastseen),$(t).find(".td-stats-version").attr("data-value",s.version),$(t).find(".td-stats-cpu").attr("data-value",s.loadavg1),$(t).find(".td-stats-mem").attr("data-value",e),$(t).find(".td-stats-swap").attr("data-value",l),$(t).find(".td-stats-disk").attr("data-value",n),$(t).find(".td-stats-calls").attr("data-value",s.calls),d?($(t).find(".td-alarm").html("<i class='glyphicon glyphicon-warning-sign'></i>"),$(t).attr("data-has-alarm",!0)):($(t).find(".td-alarm").html(""),$(t).attr("data-has-alarm",!1)),$(t).find(".td-details").html("<a href='#' onclick='displayLastStatsAsync(\""+a+"\")'><i class='glyphicon glyphicon-stats'></i> voir</a>")}}function getSettingsAsync(){return new Promise((async(t,a)=>{$.getJSON("main.php?action=getsettings",(a=>{t(a)}))}))}function saveSettingsAsync(){return new Promise((async(t,a)=>{alertram=$("#input-alert-mem").val(),alertdisk=$("#input-alert-disk").val(),alertloadavg=$("#input-alert-loadavg").val(),$("#modalsettings").modal("toggle"),$.getJSON("main.php?action=setsettings&alert-mem="+alertram+"&alert-disk="+alertdisk+"&alert-loadavg="+alertloadavg,(()=>{updateAllPBXsettingsTable(),t()}))}))}function getPBXStatsAsync(t,a){return new Promise((async(s,e)=>{$.getJSON("main.php?action=pbxstats&serial="+t+"&days="+a,(t=>{s(t)}))}))}async function drawChart(t,a,s,e){var r=new google.visualization.DataTable;r.addColumn("string","Time"),r.addColumn("number","Value"),r.addRows(a);var i={legend:{position:"none"},axisTitlesPosition:"none",enableInteractivity:!0,hAxis:{textPosition:"none"},vAxis:{minValue:0,maxValue:s,ticks:null!==e?e:"auto"},lineWidth:1,pointsVisible:!1,chartArea:{left:20,right:0},backgroundColor:{stroke:"#cdcdcd",strokeWidth:1}};new google.visualization.LineChart(t).draw(r,i)}function getStatsSerialFromCache(t){return void 0!==lastStats[t]?lastStats[t]:null}async function displayLastStatsAsync(t){$("#modalstats").modal("show"),$("#modalstats").find(".chart").html("Loading..."),$(".title-loading-stats").show(),$(".stats-nostats").hide(),$("#div-stats").hide(),$(".stat-value").html("");var a=getStatsSerialFromCache(t);if(null!==a){var s=a.totalram/1024,e=(a.totalram-a.availableram)/1024,r=100*(a.totalram-a.availableram)/a.totalram,i=a.swaptotal/1024,n=(a.swaptotal-a.swapfree)/1024,l=100*(a.swaptotal-a.swapfree)/a.swaptotal,d=moment.unix(a.date),o=parseInt(a.peersoffline)+parseInt(a.peersonline),c=moment().diff(d,"seconds"),m=parseInt(a.totaldisk),p=m-parseInt(a.freedisk),h=(100*p/m).toFixed(2);moment.unix(a.lastseen).format("DD/MM/YYYY HH:mm:ss");$(".stat-date").html(d.format("L LTS")+" - "+d.fromNow()),c>120?$(".stat-date").css("color","red"):$(".stat-date").css("color",""),$(".stat-serial").html(a.serial),$(".stat-version").html(a.version),$(".stat-memoire").html(e.toFixed(0)+" MB / "+s.toFixed(0)+" MB ("+r.toFixed(2)+"%)"),r>alertram?$(".stat-memoire").addClass("text-danger"):$(".stat-memoire").removeClass("text-danger"),$(".stat-swap").html(n.toFixed(0)+" MB / "+i.toFixed(0)+" ("+l.toFixed(2)+"%)"),$(".stat-disk").html(p+" MB / "+m+" ("+h+"%)"),h>alertdisk?$(".stat-disk").addClass("text-danger"):$(".stat-disk").removeClass("text-danger"),$(".stat-loadavg").html(a.loadavg1),$(".stat-calls").html(a.calls+" appels en cours"),$(".stat-peers").html(a.peersonline+" connectés / "+o+" total"),$(".stat-trunks").html(a.registered+" trunks enregistrés"),$("#div-stats").show();var f=await getPBXStatsAsync(t,1);setTimeout((()=>{var t=[],s=2,e=[];for(var r of f){var i=moment.unix(r.date).format("HH:mm");t.push([i,parseFloat(r.loadavg1)]),r.loadavg1>s&&(s=Math.ceil(r.loadavg1)),e.push([i,100*(parseInt(r.totalram)-parseInt(r.availableram))/a.totalram])}drawChart($(".chart-loadavg")[0],t,null,[0,s]),drawChart($(".chart-memory")[0],e,100,[0,25,50,75,100])}),1e3)}else $(".stats-nostats").show();$(".title-loading-stats").hide()}function isFiltered(t){var a=$("#inputfiltre").val().toUpperCase();return""!==a&&(-1===$(t).attr("data-nom").toUpperCase().indexOf(a)&&-1===$(t).attr("data-serial").toUpperCase().indexOf(a)&&-1===$(t).attr("data-port1").toUpperCase().indexOf(a)&&-1===$(t).attr("data-port2").toUpperCase().indexOf(a))}function filtrer(){var t=$("#checkbox-afficher-deconnectes").prop("checked"),a=$("#checkbox-afficher-alarmes").prop("checked");$("[data-type='ipbx']").each((function(s){if(isFiltered($(this)))$(this).hide();else{var e="true"===$(this).attr("data-connected"),r="true"===$(this).attr("data-has-alarm");e||t?$(this).show():$(this).hide(),a&&!r&&$(this).hide()}}))}
